use strict;
use warnings;
{
    package My::Role;
    use Moose::Role;
}
{
    package SomeClass;
    use Moose -traits => 'My::Role';
}
{
    package SubClassUseBase;
    use base qw/SomeClass/;
}
{
    package SubSubClassUseBase;
    use base qw/SubClassUseBase/;
}

use Test::More tests => 2;
use Moose::Util qw/find_meta does_role/;

my $subsubclass_meta = Moose->init_meta( for_class => 'SubSubClassUseBase' );
ok does_role($subsubclass_meta, 'My::Role'),
    'SubSubClass metaclass does role from grandparent metaclass';
my $subclass_meta = find_meta('SubClassUseBase');
TODO: {
    local $TODO = "In-between class' metaclass does not do My::Role";
    ok does_role($subclass_meta, 'My::Role'),
        'SubClass metaclass does role from parent metaclass';
}
